@ECHO OFF
call data\currentrelease.cmd
ECHO EMU Professional II TCP/IP Firmware update script
ECHO.
ECHO [32mFirmware-Version: %FWVERSION% [0m 
ECHO.

SET /p ip=Enter IP Address:
:start
ECHO.
ECHO The device with the IP Address %ip% will be updated, OK?
ECHO.
SET choice=
SET /p choice=Continue [Y]     Cancel [N]  
IF NOT '%choice%'=='' SET choice=%choice:~0,1%
IF '%choice%'=='Y' GOTO yes
IF '%choice%'=='y' GOTO yes
IF '%choice%'=='N' GOTO no
IF '%choice%'=='n' GOTO no
IF '%choice%'=='' GOTO no
ECHO "%choice%" is not valid
ECHO.
GOTO start

:no
ECHO Aborted
PAUSE
EXIT

:yes
ECHO.
ECHO Try to reach device using ping with IP Address %ip% ...
ping -n 1 %ip% | find "TTL=" >nul
IF errorlevel 1 (
    ECHO [101;93mDevice not reachable via ping, please check your network and disable all firewalls ... [0m
    ECHO.
    ECHO.
    GOTO no
) ELSE (
    ECHO [32mDevice reachable via ping  ...[0m 
    ECHO.
    GOTO checkmcumgrreachable
)


:checkmcumgrreachable
ECHO.
ECHO trying to connect to device using Update-Tool ...
data\mcumgr --timeout 3 --conntype udp --connstring=%ip%:1337 image list > NUL
IF errorlevel 1 (
    ECHO [101;93mDevice not reachable via mcumgr, please check your network and allow connections on port UDP/1337 ... [0m
    ECHO.
    GOTO no
) ELSE (
    ECHO [32mDevice reachable via mcumgr  ...[0m 
    ECHO.
    GOTO update
)


:update
ECHO Connecting device and erasing previous backup image ...
data\mcumgr --conntype udp --connstring=%ip%:1337 image erase
ECHO.
ECHO Image erased 
ECHO Upload new image ...
:: change to correct firmware file here
data\mcumgr --conntype udp --connstring=%ip%:1337 image upload data\%FWFILE%
IF errorlevel 1 (
    ECHO [101;93mError uploading image [0m
    GOTO no
)
ECHO.
ECHO Image uploaded!
data\mcumgr --conntype udp --connstring=%ip%:1337 image list
ECHO.
ECHO Activating new image ...
:: change to correct hash for firmware file here
data\mcumgr --conntype udp --connstring=%ip%:1337 image confirm %FWHASH% 
IF errorlevel 1 (
    ECHO [101;93mError confirming image [0m
    GOTO no
)
ECHO.
ECHO Restart TCP/IP modul ...
data\mcumgr --conntype udp --connstring=%ip%:1337 reset
IF errorlevel 1 (
    ECHO [101;93mError restarting device [0m
    GOTO no
)
ECHO.
ECHO [32mSent restart command, device should be up soon ...[0m 
ECHO.
PAUSE
EXIT
